;;;======================================================
;;;   Checkers Program
;;;	20 / 12 / 2004
;;;
;;;     This program was design for the second 
;;;	mandatory assignment.
;;;
;;;	
;;;	authors :
;;;		Niels Petersen (s021960)
;;;		Mathieu Texier (s041692)
;;;
;;;======================================================

(clear) ; To remove any exiting fact that could interfere with the program
(import checkers.*) ; This Jess able to call any function in the java code  
(defclass Piece checkers.Piece) ; Copying the pieces from java 

(defglobal ?*grid* = (call checkers.Grid getInstance)) ; global variabels contain Instance
(defglobal ?*game* = (call checkers.Checker getInstance)); of grid and Checker
(defglobal ?*MovePt* = 1) ; the points used for the movements
(defglobal ?*KingPt* = 3)
(defglobal ?*EatPt* =  8)

;-------------------------------------------------------------------------
;	The movement module 
;	this module contains the rules, which checks for the 
;	possible movement the pieces can preform in this and 
;	future turns
;-------------------------------------------------------------------------
(defmodule MOVEMENT) 

(deftemplate MOVEMENT::movement
    (slot piece)
    (slot action)
    (slot next)
    (slot nextNext)
    (slot point
        (type INTEGER)
        (default 0))
    (slot numberOfAction
        (default 1))
    (slot level
        (type INTEGER)
    )
    (slot pieceEaten)
    (slot multiShot)
)

;------------------------------------------------------------
;	The Rule "can_move", which checks if it
;	is possible to move a piece.
;------------------------------------------------------------

(defrule MOVEMENT::Can_move
    (MAIN::deepness ?level ?turn)
    (or
       ?PieceAdd <- (MAIN::Piece (NRS ?next) (OBJECT ?piece) (color ?turn) (number ?number) (level ?level))
       ?PieceAdd <- (MAIN::Piece (NLS ?next) (OBJECT ?piece) (color ?turn) (number ?number) (level ?level))
       ?PieceAdd <- (MAIN::Piece (PRS ?next) (OBJECT ?piece) (color ?turn) (number ?number) (level ?level) (king TRUE))
       ?PieceAdd <- (MAIN::Piece (PLS ?next) (OBJECT ?piece) (color ?turn) (number ?number) (level ?level) (king TRUE))
    )
    (not (MAIN::Piece (square ?next) (level ?l&:(<= ?l ?level))))
    (test (call ?next isLegal))
=>
    (if (eq (call ?*game* getTurn) ?turn)
    then 
            (bind ?factor 1)
    else
            (bind ?factor -1)
    )

    (if (and (call ?*grid* backLine ?next ?turn) (not (call ?piece isKing)))
        then 
            (bind ?pts (*(+ ?*MovePt* ?*KingPt*) ?factor))
    else 
            (bind ?pts (* ?*MovePt* ?factor))
    )  

    (bind ?NewPieceAdd (definstance Piece (new checkers.Piece ?number ?turn ?next (+ ?level 1)) dynamic))
    (bind ?MovementAdd (assert (movement (piece ?piece) (action "move") (next ?next) (point ?pts) (level ?level))))
    
    (if (neq ?MovementAdd FALSE) 
        then
        (assert (relate ?NewPieceAdd to ?PieceAdd by ?MovementAdd))
    else
        (retract ?NewPieceAdd)
    )
)

;------------------------------------------------------------
;	The Rule "can_eat", which checks if it
;	is possible to eat a other piece and 
;	thereby jumping two space forward.
;------------------------------------------------------------

(defrule MOVEMENT::Can_eat
    (MAIN::deepness ?level ?turn)
    (or
      ?PieceAdd <- (MAIN::Piece (NLS ?next) (NNLS ?next_next) (OBJECT ?piece) (number ?number) (color ?turn) (level ?level))
      ?PieceAdd <- (MAIN::Piece (NRS ?next) (NNRS ?next_next) (OBJECT ?piece) (number ?number) (color ?turn) (level ?level))
      ?PieceAdd <- (MAIN::Piece (PLS ?next) (PPLS ?next_next) (OBJECT ?piece) (number ?number) (color ?turn) (level ?level) (king TRUE))
      ?PieceAdd <- (MAIN::Piece (PRS ?next) (PPRS ?next_next) (OBJECT ?piece) (number ?number) (color ?turn) (level ?level) (king TRUE))
    )
    (MAIN::Piece (square ?next) (OBJECT ?pieceEaten) (number ?numberOp) (color ~?turn) );(level ?l&:(<= ?l ?level))
    (or
      (not (MAIN::Piece (square ?next_next) (number ~?numberOp) (level ?l2&:(> ?l2 ?level)) )); 
      (MAIN::Piece (square ?next_next) (number ?numberOp) (color ~?turn) )  ;(level ?l3&:(eq ?l3 (- ?l 1)))
    )
    (not (MAIN::Piece (square ?next_next) (number ?number) (color ?turn)))
    
    (test (call ?next_next isLegal))
    (test (call ?next isLegal))
    =>     
    (if (eq (call ?*game* getTurn) ?turn)
    then 
         (bind ?factor 1)
    else
         (bind ?factor -1)
    )

    (if (and (call ?*grid* backLine ?next_next ?turn) (not (call ?piece isKing)))
    then 
         (bind ?pts (+ ?*EatPt* ?*KingPt* ) ) ;(abs (call ?pieceEaten getSlotValue point))
            
    else 
         (bind ?pts ?*EatPt*) ;(abs (call ?pieceEaten getSlotValue point))
    ) 
      
    (if (call ?pieceEaten isKing)
    then
         (bind ?pts (+ ?pts ?*KingPt*))
    )

    (bind ?pts (* ?pts ?factor ))

    (bind ?PieceToAdd (new Piece ?number ?turn ?next_next (+ ?level 1)))
    (bind ?NewPieceAdd (definstance Piece ?PieceToAdd dynamic))
    (bind ?MovementAdd (assert (movement (piece ?piece) (action "eat") (next ?next) (nextNext ?next_next)(pieceEaten ?pieceEaten) (point ?pts) (level ?level))))
    (if (neq ?MovementAdd FALSE) 
    then
	(assert (relate ?NewPieceAdd to ?PieceAdd by ?MovementAdd))
    )
)

;------------------------------------------------------------
;	The Rule "multi-shot", which checks if it
;	is possible to eat multiple time in a row 
;	thereby jumping severule spaces forwarder.
;------------------------------------------------------------

(defrule MOVEMENT::multi_shot
    ?FirstShot <- (movement (piece ?piece) (action "eat") (nextNext ?next_next) (pieceEaten ?pieceEaten) (level ?level))
    ?SecondShot <- (movement (piece ?piece2) (action "eat") (nextNext ?next_next2) (pieceEaten ?pieceEaten2) (level ?l&:(eq ?l(+ ?level 1))))
    (test (neq ?FirstShot ?SecondShot))
    (test (neq ?piece ?piece2))
    (test (call ?next_next isFree))
    (test (call ?next_next2 isFree))
    ?relate1 <-(relate ?PieceAdd to ?old by ?FirstShot)
    ?relate2 <- (relate ?new to ?PieceAdd by ?SecondShot)

    (test (eq (call ?piece getColor) (call ?piece2 getColor)))
    (test (eq (call ?piece getNumber) (call ?piece2 getNumber)))
=>
    (bind ?level (call ?piece getLevel))
    (if (eq (call ?piece2 getLevel) (+ ?level 1))
        then
            (bind ?pts (abs (call ?FirstShot getSlotValue point)))    
            (bind ?ptsToAdd (call ?SecondShot getSlotValue point))
            (modify ?FirstShot (point (+ ?pts ?*EatPt* ?*EatPt* ?*EatPt* ?ptsToAdd)) (multiShot ?SecondShot))
            (modify ?SecondShot (piece ?piece))
    )
)

;------------------------------------------------------------
;	The Rule "priority", which checks if it
;	there is a "move" and a "jump" for the 
;	same piece, and removes the "move" if this 
;	condition is true.
;------------------------------------------------------------

(defrule MOVEMENT::priority (declare (salience -10))
    ?addOne <- (relate ?PieceOneAdd to ?PieceAdd by ?MovementOneAdd)
    ?addTwo <- (relate ?PieceTwoAdd to ?PieceAdd by ?MovementTwoAdd)
    (test (neq ?MovementOneAdd ?MovementTwoAdd))
=>
    (bind ?actionOne (call ?MovementTwoAdd getSlotValue action))
    (bind ?actionTwo (call ?MovementOneAdd getSlotValue action))
    (if (and (eq ?actionOne eat) (eq ?actionTwo move))
        then 
            (retract ?MovementTwoAdd)
            (retract ?PieceTwoAdd)
            (retract ?AddTwo)
    )
)
;------------------------------------------------------------
;	The Rule "eaten", which checks if it
;	is possible to be eaten by other piece  
;	if the piece moves, and if this condition 
;	is true, prevents this movement.  		
;------------------------------------------------------------


(defrule MOVEMENT::eaten (declare (salience -20))
    ?OponentMoveAdd <- (movement  (piece ?oponent) (action "eat") (pieceEaten ?pieceEaten)) 
    ?PieceAdd <- (MAIN::Piece (OBJECT ?pieceEaten) (color ?turn)) 
    (test (eq (call ?*game* getTurn) ?turn))
    (relate ?PieceAdd to ?OldPieceAdd by ?MoveAdd)
    (test (neq ?OponentMoveAdd ?MoveAdd))
    =>
    (if (eq (call ?MoveAdd getSlotValue multiShot) nil)
    then
        (bind ?pts (call ?MoveAdd getSlotValue point))
        (bind ?ptsToAdd (call ?OponentMoveAdd getSlotValue point))
        (modify ?MoveAdd (point (+ ?pts ?ptsToAdd)))
    )
)

;------------------------------------------------------------
;	The Rule "update", which uses the 
;	relationships to update the point of
;	the piece, which can perform these  
;	movements in the future.
;------------------------------------------------------------

(defrule MOVEMENT::update (declare (salience -30))
    (relate ?NewPieceAdd to ?PieceAdd by ?NewMovementAdd)
    (relate ?PieceAdd to ?OldPieceAdd by ?OldMovementAdd)
=>
    (bind ?ptsToAdd (call ?NewMovementAdd getSlotValue point))
    (bind ?pts (call ?OldMovementAdd getSlotValue point))
    (bind ?number (call ?OldMovementAdd getSlotValue numberOfAction))
    (bind ?level (call ?NewMovementAdd getSlotValue level))
    (modify ?OldMovementAdd (point (+ ?pts (/ ?ptsToAdd ?level))) (numberOfAction  (+ ?number (/ 1 (+ ?level 1)))))
)

;----------------------------------------------------------------------
;		The Reasoning module 
;	this module contains the rules, which does the actual 
;	movement of the pieces, by checking points of every piece  
;	and call either the "move" or "jump" function in java
;----------------------------------------------------------------------

(defmodule REASONING)

;------------------------------------------------------------
;	The Rule "max", which checks all the
;	pieces's points to find which piece   
;	has the greatest point. 
;------------------------------------------------------------

(defrule REASONING::max 
    ?old <- (find_max ?curent $?old_piece)
    ?p <- (MOVEMENT::movement (point ?Point) (nextNext ?next_next) (numberOfAction ?number) (action ?action)(level 0) (piece ?piece) (pieceEaten ?pieceEaten))
    (test (eq (call ?piece getColor) (call ?*game* getTurn)))
    (MAIN::deepness ?level ?turn)
=>
    (bind ?continue TRUE)
    (if (eq ?action "eat")
        then 
        
        (if (or (neq (call ?pieceEaten getLevel) 0) (not (call ?next_next isFree)))
            then
            (bind ?continue FALSE)
        )
    )

    (if (eq ?continue TRUE)
    then
        (bind ?max (/ ?Point ?number))

        (if (> ?max ?curent)
        then 
           (assert (find_max ?max ?p))
           (retract ?old)
        ) 
    )
)

;------------------------------------------------------------
;	The Rule "Control", which handles the 
;	the moving of the piece, by checking 
;	which movement it is, and calling the 
; 	approriate Java function. 
;------------------------------------------------------------

(defrule REASONING::Control (declare (salience -10))
    ?find <- (find_max ?pts ?p)
    ?p  <- (MOVEMENT::movement (piece ?piece) (action ?action) (next ?next) (point ?Point) (multiShot $?multiShot))
    =>
    (if (eq ?action "eat") 
        then 
            (printout t (call ?piece toString) " -> jump " (call ?next toString) crlf)
            (call ?piece jump ?next)
            (assert (remove ?next))
            (if (neq ?multiShot nil) 
                then
                (bind ?pieceEaten (call ?multiShot getSlotValue pieceEaten))
                (bind ?next_next (call ?multiShot getSlotValue nextNext))
                (if (and (eq (call ?pieceEaten getLevel) 0) (call ?next_next isFree))
                    then
                    (printout t "multiPas "crlf)
                    (retract ?find)
                    (assert (find_max ?pts ?multiShot))
                )
            )
            
    )
    (if (eq ?action "move")
        then 
            (printout t (call ?piece toString) " -> move " (call ?next toString) crlf)
            (call ?piece move ?next)   
    )
)

;------------------------------------------------------------
;	The Rule "Remove" and "cleanup", which handles the 
;	removing of used facts. 
;------------------------------------------------------------

(defrule REASONING::Remove (declare (salience -20))
    ?add <- (remove ?pieceOnSquare)
    ?piece_to_retract <- (MAIN::Piece (OBJECT ?piece) (square ?pieceOnSquare))
    =>
    (retract ?piece_to_retract)
    (retract ?add)
    (assert (remove ?pieceOnSquare))
)

(defrule REASONING::Cleanup (declare (salience -30))
    (or
        ?add <- (remove ?)
        ?add <- (MAIN::Piece (level ?level&:(> ?level 0)))
    )
    =>
    (retract ?add)
)